//
//  XMLEntityDecoder.m
//  MobileDaxhotel
//
//  Created by Raphael Schweikert on 24.12.08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "XMLEntityDecoder.h"

@implementation XMLEntityDecoder

+ (NSString *) entityStringXMLWithContents:(NSString *)contents {
    static NSString *xmlData;
    if(!xmlData) {
        xmlData = [[NSString alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"string" ofType:@"xml"]];
    }
    return [NSString stringWithFormat:xmlData, contents];
}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)characters {
    [resultString appendString:characters];
}

- (NSString *) stringWithDecodedEntitiesInString:(NSString *)string {
    resultString = [[NSMutableString alloc] init];
    NSString* xmlStr = [XMLEntityDecoder entityStringXMLWithContents:string];
    NSData *data = [xmlStr dataUsingEncoding:NSUTF8StringEncoding allowLossyConversion:YES];
    NSXMLParser* parser = [[NSXMLParser alloc] initWithData:data];
    [parser setDelegate:self];
    [parser parse];
//    if([parser parserError] != nil && [[parser parserError] code] != NSXMLParserAttributeRedefinedError) {
//        NSLog(@"XML Parser error: %@ for string %@", [parser parserError], string);
//    }
    [parser release];
    return [resultString autorelease];
}

@end
