//
//  DetailView.h
//  MobileDaxhotel
//
//  Created by Raphael Schweikert on 24.12.08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>

@class EpisodeImageView, MobileDaxhotelAppDelegate;

@interface DetailViewController : UIViewController {
    IBOutlet UISegmentedControl *segments;
    IBOutlet UIWebView *textView;
    IBOutlet MobileDaxhotelAppDelegate *appDelegate;
    EpisodeImageView *imagesView;
    NSString *overviewWebContent;
    NSString *detailWebContent;
    NSDictionary *currentEpisode;
    NSDictionary *currentSeries;
    NSUInteger overviewSegmentIndex;
    NSUInteger detailSegmentIndex;
    NSUInteger imagesSegmentIndex;
    NSUInteger originalSegmentIndex;
    double imageDisplayTime;
}

- (void) displayEpisode:(NSDictionary *)episode ofSeries:(NSDictionary *)series updateTintColor:(BOOL)updateTintColor;
- (IBAction) clickedButton;
- (void) initImagesView;
- (void) clearTextView;
- (NSUInteger) currentEpisodeId;
+ (NSString *) webOverviewFormat;
+ (NSString *) webDetailFormat;

@end
