//
//  SearchEpisodeSelectionTableController.h
//  MobileDaxhotel
//
//  Created by Raphael Schweikert on 17.03.09.
//  Copyright 2009 Raphael Schweikert. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "EpisodeSelectionTableController.h"
#import "DetailViewController.h"
#import "MobileDaxhotelAppDelegate.h"

@interface SearchEpisodeSelectionTableController : EpisodeSelectionTableController {
    NSArray *displayedEpisodes;
}

@property(nonatomic, retain) NSArray *displayedEpisodes;

- (void) updateTable;
- (void) scrollToTop;
- (void) deselect;
- (NSDictionary *)episodeForRowAtIndexPath:(NSIndexPath *)indexPath;

@end
